% SCRIPT DI INIZIALIZZAZIONE PARAMETRI PER AEROSTATO AD ARIA CALDA

if(~exist('init_done'))
V=[];
m=[];
theta_t=[];
f = [];

rho_a = 1.2928;
c_a = 1008;
g=9.80665;

init_done = 1;
end

while isempty(m) 
    m = input('Inserire le prime due cifre (esclusi zeri) del proprio numero di matricola:\n\n');
end

text=sprintf('\nMassa dell''aerostato: %3.0f kg\n',m); disp(text);

while isempty(V) 
    V = input('Inserire l''ultima cifra del proprio numero di matricola (se 0 -> 5):\n\n');
end

V = V*m*2;
C = V*rho_a*c_a;

text=sprintf('\nVolume del pallone dell''aerostato: %3.0f m^3\n',V); disp(text);

text=sprintf('\nCapacita'' termica dell''aerostato: %6.0f J/C\n',C); disp(text);

while isempty(theta_t) 
    theta_t = input('Inserire la penultima cifra del proprio numero di matricola (se 0 -> 4):\n\n');
end

theta_t = theta_t/50;

text=sprintf('\nResistenza termica tra aerostato e aria esterna: %1.3f C/W\n',theta_t); disp(text);

while isempty(f) 
    f = input('Inserire le ultime due cifre (esclusi zeri) del proprio numero di matricola:\n\n');
end

f = f / 10;

text=sprintf('\nCoefficiente di attrito viscoso aerodinamico: %1.2f N s / m\n',f); disp(text);


%Temperatura ambiente (20 C, riportati in K)
Ta = 20+273.15;
%SET-POINT:
x1_d = Ta/(1-m/(V*rho_a));
x2_d = 120;
x3_d = 0;
%CONDIZIONI INIZIALI:
x1_0 = x1_d;
x2_0 = 100;
x3_0 = 0;

text=sprintf('\nCondizioni iniziali: temperatura interna (x1_0) = %1.2f K, quota (x2_0) = %1.2f m, velocita'' ascensionale(x3_0) = %1.2f m/s\n',x1_0,x2_0,x3_0);
disp(text);


text=sprintf('\nCondizioni desiderate (set-point): temperatura interna (x1_d) = %1.2f K, quota (x2_d) = %1.2f m, velocita'' ascensionale(x3_d) = %1.2f m/s\n',x1_d,x2_d,x3_d);
disp(text);


clear text;