%%%
%%% Progetto filtro di Kalman per il problema LQG del balloon
%%%

%%% Filtro di Kalman con 4 ingressi e 3 uscite

%%%
%%% Si fa riferimento al filtro di Kalman per il modello
%%%
%%%       .
%%%       x = Ax + Bu + Gw            {State equation}
%%%       y = Cx + Du + Hw + v        {Measurements}
%%%

G_balloon = B_balloon;

%%% Verificare la controllabilita' della coppia (A_balloon,Gballoon)
nc = rank(ctrb(A_balloon,G_balloon))

%%% Verificare l'osservabilit della coppia (A_balloon,Gballoon)
no = rank(obsv(A_balloon,C_balloon))


Wballoon = 1e-6;                          % = E{ww'},     
Vballoon = diag([1e-7 1e-7 1e-7]); % = E{vv'}

[Pkf,Ekf,Kkft] = care(A_balloon',C_balloon',G_balloon*Wballoon*G_balloon',Vballoon); % CARE duale!

Kkf = Kkft'; 

%[Kkf,Pkf,Ekf] = lqr(A_balloon',C_balloon',G_balloon*Wballoon*G_balloon',Vballoon)

%%% Matrici del filtro di Kalman: E' un osservatore dello stato!

Akf = A_balloon - Kkf * C_balloon;
Bkf = [B_balloon Kkf];
Ckf = eye(3);
Dkf = zeros(3,4);

return
